"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.runPreProcess = runPreProcess;
var _path = _interopRequireWildcard(require("path"));
var _fs = require("fs");
var _child_process = require("child_process");
function _getRequireWildcardCache(e) { if ("function" != typeof WeakMap) return null; var r = new WeakMap(), t = new WeakMap(); return (_getRequireWildcardCache = function (e) { return e ? t : r; })(e); }
function _interopRequireWildcard(e, r) { if (!r && e && e.__esModule) return e; if (null === e || "object" != typeof e && "function" != typeof e) return { default: e }; var t = _getRequireWildcardCache(r); if (t && t.has(e)) return t.get(e); var n = { __proto__: null }, a = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var u in e) if ("default" !== u && {}.hasOwnProperty.call(e, u)) { var i = a ? Object.getOwnPropertyDescriptor(e, u) : null; i && (i.get || i.set) ? Object.defineProperty(n, u, i) : n[u] = e[u]; } return n.default = e, t && t.set(e, n), n; }
function runPreProcess({
  options,
  option,
  nodemon,
  spawnSync
}) {
  const {
    preprocess
  } = options;
  const preprocessorPath = preprocess.runner ? _path.default.join(process.cwd(), preprocess.runner) : '';
  const preprocessCli = preprocess.stopNodemon ? 'node' : nodemon;
  if (preprocessorPath && (0, _fs.existsSync)(preprocessorPath)) {
    const preprocessorDirPath = (0, _path.dirname)(preprocessorPath);
    const watchOptions = preprocessCli === nodemon ? ['--watch', preprocessorDirPath] : [];
    // eslint-disable-next-line default-case
    switch (option) {
      case 'start':
      case 'docs':
        (0, _child_process.spawn)(preprocessCli, [preprocessorPath, ...watchOptions], {
          stdio: 'inherit',
          cwd: preprocessorDirPath
        });
        // NOTE:  it's ok if we not close this here
        // Because when node server stops this program will be closed So this  nodemon  will be killed  as well
        break;
      case 'nowatchstart':
      case 'devbuild':
      case 'build:library:es':
      case 'build:component:es':
      case 'build:library:cmjs':
      case 'build:component:cmjs':
        spawnSync('node', [preprocessorPath], {
          stdio: 'inherit',
          cwd: preprocessorPath.slice(0, preprocessorPath.lastIndexOf('/') + 1)
        });
        break;
      case 'preprocessor':
        {
          const result = spawnSync(preprocessCli, [preprocessorPath, ...watchOptions], {
            stdio: 'inherit',
            cwd: preprocessorDirPath
          });
          process.exit(result.status);
          break;
        }
    }
  } else if (option === 'preprocess') {
    console.error(`preProcessor not exists ${preprocessorPath}`);
    process.exit(0);
  }
}