"use strict";

// utils/getJsResourceKeys.js
const fs = require('fs');
const readline = require('readline');
function getJsResourceKeys(filePath) {
  const keys = new Set();
  const fileContent = fs.readFileSync(filePath, 'utf8');
  const lines = fileContent.split(/\r?\n/);
  for (const line of lines) {
    const trimmedLine = line.trim();
    if (trimmedLine && !trimmedLine.startsWith('#')) {
      const equalIndex = trimmedLine.indexOf('=');
      if (equalIndex > 0) {
        const key = trimmedLine.slice(0, equalIndex).trim();
        keys.add(key);
      }
    }
  }
  return keys;
}
module.exports = getJsResourceKeys;