"use strict";

// i18nChunkUtils.js
const crypto = require('crypto');
function hashKey(key) {
  return crypto.createHash('md5').update(key).digest('hex');
}
function getChunkIdForKey(key) {
  const hash = hashKey(key);
  const numChunks = 100;
  const numericHash = parseInt(hash.substring(0, 8), 16);
  const chunkId = numericHash % numChunks;
  return `chunk-${chunkId}`;
}
module.exports = {
  hashKey,
  getChunkIdForKey
};